package net.mcreator.crafting_the_uncraftable;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.fml.common.registry.EntityEntry;
import net.minecraftforge.fml.common.network.NetworkRegistry;
import net.minecraftforge.fml.common.network.IGuiHandler;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.event.FMLServerStartingEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.SidedProxy;
import net.minecraftforge.fml.common.Mod.Instance;
import net.minecraftforge.fml.common.Mod.EventHandler;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.common.IWorldGenerator;
import net.minecraftforge.fml.common.IFuelHandler;
import net.minecraftforge.fluids.FluidRegistry;
import net.minecraftforge.event.RegistryEvent;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.client.event.ModelRegistryEvent;

import net.minecraft.world.gen.IChunkGenerator;
import net.minecraft.world.chunk.IChunkProvider;
import net.minecraft.world.biome.Biome;
import net.minecraft.world.World;
import net.minecraft.potion.Potion;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Item;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.block.Block;

import java.util.function.Supplier;
import java.util.Random;
import java.util.List;
import java.util.ArrayList;

@Mod(modid = crafting_the_uncraftable.MODID, version = crafting_the_uncraftable.VERSION)
public class crafting_the_uncraftable implements IFuelHandler, IWorldGenerator {

	public static final String MODID = "crafting_the_uncraftable";
	public static final String VERSION = "1.0.0";
	@SidedProxy(clientSide = "net.mcreator.crafting_the_uncraftable.ClientProxycrafting_the_uncraftable", serverSide = "net.mcreator.crafting_the_uncraftable.CommonProxycrafting_the_uncraftable")
	public static CommonProxycrafting_the_uncraftable proxy;
	@Instance(MODID)
	public static crafting_the_uncraftable instance;
	public final List<ModElement> elements = new ArrayList<>();
	public final List<Supplier<Block>> blocks = new ArrayList<>();
	public final List<Supplier<Item>> items = new ArrayList<>();
	public final List<Supplier<Biome>> biomes = new ArrayList<>();
	public final List<Supplier<EntityEntry>> entities = new ArrayList<>();
	public final List<Supplier<Potion>> potions = new ArrayList<>();

	public crafting_the_uncraftable() {
		FluidRegistry.enableUniversalBucket();
		elements.add(new MCreatorEyltra(this));
		elements.add(new MCreatorMagicFeather(this));
		elements.add(new MCreatorMagicFeatherRecipe(this));
		elements.add(new MCreatorNeverStar(this));
		elements.add(new MCreatorNameTag(this));
		elements.add(new MCreatorChain(this));
		elements.add(new MCreatorChainRecipe(this));
		elements.add(new MCreatorChainHelmet(this));
		elements.add(new MCreatorChainChestplate(this));
		elements.add(new MCreatorChainLeggings(this));
		elements.add(new MCreatorChainBoots(this));
		elements.add(new MCreatorSadle(this));
		elements.add(new MCreatorIronHorseArmor(this));
		elements.add(new MCreatorGoldHorseArmor(this));
		elements.add(new MCreatorDiamondHorseArmour(this));
		elements.add(new MCreatorEnchantedGoldenApple(this));
		elements.add(new MCreatorEmtpySpawnEgg(this));
		elements.add(new MCreatorEmptySpawnEgg(this));
		elements.add(new MCreatorTotemOfUndying(this));
		elements.add(new MCreatorZombieSpawnEgg(this));
		elements.add(new MCreatorSkelotonSpawnEgg(this));
		elements.add(new MCreatorSpiderSpawnEgg(this));
		elements.add(new MCreatorEmptyTube(this));
		elements.add(new MCreatorTubeOfPosion(this));
		elements.add(new MCreatorEmptyTubeRecipe(this));
		elements.add(new MCreatorTubeOfPosionA(this));
		elements.add(new MCreatorTubeOfPosionB(this));
		elements.add(new MCreatorCaveSpiderSpawnEgg(this));
		elements.add(new MCreatorPigSpawnEgg(this));
		elements.add(new MCreatorSheepSpawnEggA(this));
		elements.add(new MCreatorSheepSpawnEggB(this));
		elements.add(new MCreatorCowSpawnEggA(this));
		elements.add(new MCreatorCowSpawnEggB(this));
		elements.add(new MCreatorRabitSpawnEggA(this));
		elements.add(new MCreatorRabitSpawnEggB(this));
		elements.add(new MCreatorChickenSpawnEgg(this));
		elements.add(new MCreatorSquidSpawnEgg(this));
		elements.add(new MCreatorCreeperSpawnEgg(this));
		elements.add(new MCreatorEndermanSpawnEgg(this));
		elements.add(new MCreatorSilverfishSpawnEgg(this));
		elements.add(new MCreatorEndermiteSpawnEgg(this));
		elements.add(new MCreatorZombiePigmanSpawnEgg(this));
		elements.add(new MCreatorSpawner(this));
		elements.add(new MCreatorSkelotonSkull(this));
		elements.add(new MCreatorWitherSkull(this));
		elements.add(new MCreatorZombieHead(this));
		elements.add(new MCreatorCreeperHead(this));
		elements.add(new MCreatorDragonHead(this));
		elements.add(new MCreatorDragonEgg(this));
	}

	@Override
	public int getBurnTime(ItemStack fuel) {
		for (ModElement element : elements) {
			int ret = element.addFuel(fuel);
			if (ret != 0)
				return ret;
		}
		return 0;
	}

	@Override
	public void generate(Random random, int chunkX, int chunkZ, World world, IChunkGenerator cg, IChunkProvider cp) {
		elements.forEach(element -> element.generateWorld(random, chunkX * 16, chunkZ * 16, world, world.provider.getDimension(), cg, cp));
	}

	@SubscribeEvent
	public void registerBlocks(RegistryEvent.Register<Block> event) {
		event.getRegistry().registerAll(blocks.stream().map(Supplier::get).toArray(Block[]::new));
	}

	@SubscribeEvent
	public void registerItems(RegistryEvent.Register<Item> event) {
		event.getRegistry().registerAll(items.stream().map(Supplier::get).toArray(Item[]::new));
	}

	@SubscribeEvent
	public void registerBiomes(RegistryEvent.Register<Biome> event) {
		event.getRegistry().registerAll(biomes.stream().map(Supplier::get).toArray(Biome[]::new));
	}

	@SubscribeEvent
	public void registerEntities(RegistryEvent.Register<EntityEntry> event) {
		event.getRegistry().registerAll(entities.stream().map(Supplier::get).toArray(EntityEntry[]::new));
	}

	@SubscribeEvent
	public void registerPotions(RegistryEvent.Register<Potion> event) {
		event.getRegistry().registerAll(potions.stream().map(Supplier::get).toArray(Potion[]::new));
	}

	@SubscribeEvent
	public void registerSounds(RegistryEvent.Register<net.minecraft.util.SoundEvent> event) {
	}

	@SubscribeEvent
	@SideOnly(Side.CLIENT)
	public void registerModels(ModelRegistryEvent event) {
		elements.forEach(element -> element.registerModels(event));
	}

	@EventHandler
	public void preInit(FMLPreInitializationEvent event) {
		MinecraftForge.EVENT_BUS.register(this);
		GameRegistry.registerFuelHandler(this);
		GameRegistry.registerWorldGenerator(this, 5);
		NetworkRegistry.INSTANCE.registerGuiHandler(this, new GuiHandler());
		elements.forEach(element -> element.preInit(event));
		proxy.preInit(event);
	}

	@EventHandler
	public void init(FMLInitializationEvent event) {
		elements.forEach(element -> element.init(event));
		proxy.init(event);
	}

	@EventHandler
	public void serverLoad(FMLServerStartingEvent event) {
		elements.forEach(element -> element.serverLoad(event));
	}

	public static class GuiHandler implements IGuiHandler {

		@Override
		public Object getServerGuiElement(int id, EntityPlayer player, World world, int x, int y, int z) {
			return null;
		}

		@Override
		public Object getClientGuiElement(int id, EntityPlayer player, World world, int x, int y, int z) {
			return null;
		}
	}

	public static class ModElement {

		public static crafting_the_uncraftable instance;

		public ModElement(crafting_the_uncraftable instance) {
			this.instance = instance;
		}

		public void init(FMLInitializationEvent event) {
		}

		public void preInit(FMLPreInitializationEvent event) {
		}

		public void generateWorld(Random random, int posX, int posZ, World world, int dimID, IChunkGenerator cg, IChunkProvider cp) {
		}

		public void serverLoad(FMLServerStartingEvent event) {
		}

		public void registerModels(ModelRegistryEvent event) {
		}

		public int addFuel(ItemStack fuel) {
			return 0;
		}
	}
}
